module TestRunner
  module Assert
    class Check
      singleton_class.send :attr_reader, :block, :name

      attr :argument

      def initialize subject_thunk, argument
        @argument = argument
        @subject_thunk = subject_thunk
      end

      def evaluate
        self.class.block.call self, @argument
        freeze
      end

      def expect_error
        @subject_thunk.expect_error
      end

      def fail message
        passed = negated? ^ yield
        @fail_message = message unless passed
      end

      def fail_message
        "expected #{Assert.inspect subject} to#{" not" if negated?} #{@fail_message}"
      end

      def failed?
        @fail_message ? true : false
      end

      def negated?
        @negated ? true : false
      end

      def negate
        @negated = !@negated
      end

      def passed?
        not failed?
      end

      def subject
        @expected_error or @subject_thunk.call
      end

    end
  end
end
