module TestRunner
  module Assert
    module Checks
      module Registry
        def self.extended base
          base.instance_variable_set :@registry, {}
        end

        def self.define check_name, block
          klass = Class.new Check
          klass.instance_variable_set :@block, block
          constant_name = Util.to_camel_case check_name
          const_set constant_name, klass
          klass
        end

        attr :registry

        def register check_name, &block
          registry[check_name] = Registry.define check_name, block
        end

        def resolve check_name, &block
          block ||= -> * do raise MissingCheck.new check_name end
          registry.fetch check_name, &block
        end
        alias_method :[], :resolve
      end
    end
  end
end
